Index: palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 2938)
@@ -815,16 +1034,53 @@
 !-- Initial value of fu, fv, fw
     IF ( simulated_time == 0.0_wp .AND. .NOT. velocity_seed_initialized )  THEN
-       CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fu )
-       CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fv )
-       CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fw )
+       CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fu_yz, id_stg_left )
+       CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fv_yz, id_stg_left )
+       CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fw_yz, id_stg_left )
+
+       IF ( forcing  .OR.  nest_domain )  THEN
+!
+!--       Generate turbulence at right boundary
+          CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fu_yz, id_stg_right )
+          CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fv_yz, id_stg_right )
+          CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fw_yz, id_stg_right )
+!
+!--       Generate turbulence at north boundary
+          CALL stg_generate_seed_xz( nux, nuz, bux, buz, fu_xz, id_stg_north )
+          CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fv_xz, id_stg_north )
+          CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fw_xz, id_stg_north )
+!
+!--       Generate turbulence at south boundary
+          CALL stg_generate_seed_xz( nux, nuz, bux, buz, fu_xz, id_stg_south )
+          CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fv_xz, id_stg_south )
+          CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fw_xz, id_stg_south )
+       ENDIF
        velocity_seed_initialized = .TRUE.
     ENDIF
 !
 !-- New set of fu, fv, fw
-    CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fuo )
-    CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fvo )
-    CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fwo )
-
-    IF ( myidx == id_inflow )  THEN
+    CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fuo_yz, id_stg_left )
+    CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fvo_yz, id_stg_left )
+    CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fwo_yz, id_stg_left )
+
+    IF ( forcing  .OR.  nest_domain )  THEN
+!
+!--       Generate turbulence at right boundary
+          CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fuo_yz, id_stg_right )
+          CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fvo_yz, id_stg_right )
+          CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fwo_yz, id_stg_right )
+!
+!--       Generate turbulence at north boundary
+          CALL stg_generate_seed_xz( nux, nuz, bux, buz, fuo_xz, id_stg_north )
+          CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fvo_xz, id_stg_north )
+          CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fwo_xz, id_stg_north )
+!
+!--       Generate turbulence at south boundary
+          CALL stg_generate_seed_xz( nux, nuz, bux, buz, fuo_xz, id_stg_south )
+          CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fvo_xz, id_stg_south )
+          CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fwo_xz, id_stg_south )
+    ENDIF
+!
+!-- Turbulence generation at left and or right boundary
+    IF ( myidx == id_stg_left  .OR.  myidx == id_stg_right )  THEN
 
        DO  j = nysg, nyng
@@ -833,22 +1089,22 @@
 !--          Update fu, fv, fw following Eq. 14 of Xie and Castro (2008)
              IF ( tu(k) == 0.0_wp )  THEN
-                fu(k,j) = fuo(k,j)
+                fu_yz(k,j) = fuo_yz(k,j)
              ELSE
-                fu(k,j) = fu(k,j) * EXP( -pi * dt_stg * 0.5_wp / tu(k) ) +     &
-                         fuo(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tu(k) ) )
+                fu_yz(k,j) = fu_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tu(k) ) +     &
+                         fuo_yz(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tu(k) ) )
              ENDIF
 
              IF ( tv(k) == 0.0_wp )  THEN
-                fv(k,j) = fvo(k,j)
+                fv_yz(k,j) = fvo_yz(k,j)
              ELSE
-                fv(k,j) = fv(k,j) * EXP( -pi * dt_stg * 0.5_wp / tv(k) ) +     &
-                         fvo(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tv(k) ) )
+                fv_yz(k,j) = fv_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tv(k) ) +     &
+                         fvo_yz(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tv(k) ) )
              ENDIF
 
              IF ( tw(k) == 0.0_wp )  THEN
-                fw(k,j) = fwo(k,j)
+                fw_yz(k,j) = fwo_yz(k,j)
              ELSE
-                fw(k,j) = fw(k,j) * EXP( -pi * dt_stg * 0.5_wp / tw(k) ) +     &
-                         fwo(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tw(k) ) )
+                fw_yz(k,j) = fw_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tw(k) ) +     &
+                         fwo_yz(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tw(k) ) )
              ENDIF
 !
@@ -856,24 +1112,24 @@
 !--          Additional factors are added to improve the variance of v and w
              IF( k == 0 )  THEN
-                inflow_dist(k,j,1,1) = 0.0_wp
-                inflow_dist(k,j,2,1) = 0.0_wp
-                inflow_dist(k,j,3,1) = 0.0_wp
-                inflow_dist(k,j,4,1) = 0.0_wp
-                inflow_dist(k,j,5,1) = 0.0_wp
+                dist_yz(k,j,1) = 0.0_wp
+                dist_yz(k,j,2) = 0.0_wp
+                dist_yz(k,j,3) = 0.0_wp
+!                 dist_yz(k,j,4) = 0.0_wp
+!                 dist_yz(k,j,5) = 0.0_wp
              ELSE
-                inflow_dist(k,j,1,1) = a11(k) * fu(k,j)
+                dist_yz(k,j,1) = a11(k) * fu_yz(k,j)
                 !experimental test of 1.2
-                inflow_dist(k,j,2,1) = ( SQRT( a22(k) / MAXVAL(a22) )          &
+                dist_yz(k,j,2) = ( SQRT( a22(k) / MAXVAL(a22) )                   &
                                          * 1.2_wp )                            &
-                                       * (   a21(k) * fu(k,j)                  &
-                                           + a22(k) * fv(k,j) )
-                inflow_dist(k,j,3,1) = ( SQRT(a33(k) / MAXVAL(a33) )           &
+                                       * (   a21(k) * fu_yz(k,j)                  &
+                                           + a22(k) * fv_yz(k,j) )
+                dist_yz(k,j,3) = ( SQRT(a33(k) / MAXVAL(a33) )                    &
                                          * 1.3_wp )                            &
-                                       * (   a31(k) * fu(k,j)                  &
-                                           + a32(k) * fv(k,j)                  &
-                                           + a33(k) * fw(k,j) )
+                                       * (   a31(k) * fu_yz(k,j)                  &
+                                           + a32(k) * fv_yz(k,j)                  &
+                                           + a33(k) * fw_yz(k,j) )
                 ! Calculation for pt and e not yet implemented
-                inflow_dist(k,j,4,1) = 0.0_wp
-                inflow_dist(k,j,5,1) = 0.0_wp
+!                 dist_yz(k,j,4) = 0.0_wp
+!                 dist_yz(k,j,5) = 0.0_wp
              ENDIF
 
@@ -885,34 +1141,216 @@
 !--    This correction factor insures that the mass flux is preserved at the
 !--    inflow boundary
-       mc_factor_l = 0.0_wp
-       mc_factor   = 0.0_wp
-       DO  j = nys, nyn
+       IF ( .NOT. forcing  .AND.  .NOT. nest_domain )  THEN 
+          mc_factor_l = 0.0_wp
+          mc_factor   = 0.0_wp
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                mc_factor_l = mc_factor_l + dzw(k)  *                          &
+                              ( mean_inflow_profiles(k,1) + dist_yz(k,j,1) )
+             ENDDO
+          ENDDO
+
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( mc_factor_l, mc_factor,  &
+                              1, MPI_REAL, MPI_SUM, comm1dy, ierr )
+#else
+          mc_factor = mc_factor_l
+#endif
+
+          mc_factor = volume_flow_initial(1) / mc_factor
+
+!
+!--       Add disturbance at the inflow
+          DO  j = nysg, nyng
+             DO  k = nzb, nzt+1
+                 u(k,j,-nbgp+1:0) = ( mean_inflow_profiles(k,1) +              &
+                                      dist_yz(k,j,1)             ) * mc_factor
+                 v(k,j,-nbgp:-1)  = ( mean_inflow_profiles(k,2) +              &
+                                      dist_yz(k,j,2)             ) * mc_factor
+                 w(k,j,-nbgp:-1)  =   dist_yz(k,j,3)               * mc_factor
+             ENDDO
+          ENDDO
+
+       ELSE
+!
+!--       First, calculate volume flow at yz boundary
+          IF ( myidx == id_stg_left  )  i = nxl
+          IF ( myidx == id_stg_right )  i = nxr+1
+
+          volume_flow_l = 0.0_wp
+          volume_flow   = 0.0_wp
+          mc_factor_l   = 0.0_wp
+          mc_factor     = 0.0_wp
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                volume_flow_l = volume_flow_l + u(k,j,i) * dzw(k) * dy         &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &   
+                                              BTEST( wall_flags_0(k,j,i), 1 ) )
+
+                mc_factor_l = mc_factor_l     + ( u(k,j,i) + dist_yz(k,j,1) )  &
+                                                         * dzw(k) * dy         &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &   
+                                              BTEST( wall_flags_0(k,j,i), 1 ) )
+             ENDDO
+          ENDDO
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( volume_flow_l, volume_flow,                      &
+                              1, MPI_REAL, MPI_SUM, comm1dy, ierr )
+          CALL MPI_ALLREDUCE( mc_factor_l, mc_factor,                          &
+                              1, MPI_REAL, MPI_SUM, comm1dy, ierr )
+#else
+          volume_flow = volume_flow_l
+          mc_factor   = mc_factor_l
+#endif
+
+          mc_factor = volume_flow / mc_factor
+
+!
+!--       Add disturbances
+          IF ( myidx == id_stg_left  )  THEN
+
+             DO  j = nysg, nyng
+                DO  k = nzb, nzt+1
+                   u(k,j,-nbgp+1:0) = ( u(k,j,-nbgp+1:0) + dist_yz(k,j,1) )    &
+                                        * mc_factor
+                   v(k,j,-nbgp:-1)  = ( v(k,j,-nbgp:-1)  + dist_yz(k,j,2)  )   &
+                                        * mc_factor
+                   w(k,j,-nbgp:-1)  = ( w(k,j,-nbgp:-1)  + dist_yz(k,j,3)  )   &
+                                        * mc_factor
+                ENDDO
+             ENDDO
+          ENDIF
+          IF ( myidx == id_stg_right  )  THEN
+
+             DO  j = nysg, nyng
+                DO  k = nzb, nzt+1
+                   u(k,j,nxr+1:nxr+nbgp) = ( u(k,j,nxr+1:nxr+nbgp) +           &
+                                             dist_yz(k,j,1) ) * mc_factor
+                   v(k,j,nxr+1:nxr+nbgp) = ( v(k,j,nxr+1:nxr+nbgp) +           &
+                                             dist_yz(k,j,2) ) * mc_factor
+                   w(k,j,nxr+1:nxr+nbgp) = ( w(k,j,nxr+1:nxr+nbgp) +           &
+                                             dist_yz(k,j,3) ) * mc_factor
+                ENDDO
+             ENDDO
+          ENDIF
+       ENDIF
+
+    ENDIF
+!
+!-- Turbulence generation at north and south boundary
+    IF ( myidy == id_stg_north  .OR.  myidy == id_stg_south )  THEN
+
+       DO  i = nxlg, nxrg
+          DO  k = nzb, nzt + 1
+!
+!--          Update fu, fv, fw following Eq. 14 of Xie and Castro (2008)
+             IF ( tu(k) == 0.0_wp )  THEN
+                fu_xz(k,i) = fuo_xz(k,i)
+             ELSE
+                fu_xz(k,i) = fu_xz(k,i) * EXP( -pi * dt_stg * 0.5_wp / tu(k) ) +     &
+                         fuo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tu(k) ) )
+             ENDIF
+
+             IF ( tv(k) == 0.0_wp )  THEN
+                fv_xz(k,i) = fvo_xz(k,i)
+             ELSE
+                fv_xz(k,i) = fv_xz(k,i) * EXP( -pi * dt_stg * 0.5_wp / tv(k) ) +     &
+                         fvo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tv(k) ) )
+             ENDIF
+
+             IF ( tw(k) == 0.0_wp )  THEN
+                fw_xz(k,i) = fwo_xz(k,i)
+             ELSE
+                fw_xz(k,i) = fw_xz(k,i) * EXP( -pi * dt_stg * 0.5_wp / tw(k) ) +     &
+                         fwo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tw(k) ) )
+             ENDIF
+!
+!--          Lund rotation following Eq. 17 in Xie and Castro (2008).
+!--          Additional factors are added to improve the variance of v and w
+             IF( k == 0 )  THEN
+                dist_xz(k,i,1) = 0.0_wp
+                dist_xz(k,i,2) = 0.0_wp
+                dist_xz(k,i,3) = 0.0_wp
+
+             ELSE
+                dist_xz(k,i,1) = a11(k) * fu_xz(k,i)
+                !experimental test of 1.2
+                dist_xz(k,i,2) = ( SQRT( a22(k) / MAXVAL(a22) )                &
+                                         * 1.2_wp )                            &
+                                       * (   a21(k) * fu_xz(k,i)               &
+                                           + a22(k) * fv_xz(k,i) )
+                dist_xz(k,i,3) = ( SQRT(a33(k) / MAXVAL(a33) )                 &
+                                         * 1.3_wp )                            &
+                                       * (   a31(k) * fu_xz(k,i)               &
+                                           + a32(k) * fv_xz(k,i)               &
+                                           + a33(k) * fw_xz(k,i) )
+             ENDIF
+
+          ENDDO
+       ENDDO
+!
+!--    Mass flux correction following Kim et al. (2013)
+!--    This correction factor insures that the mass flux is preserved at the
+!--    inflow boundary.
+!--    First, calculate volume flow at xz boundary
+       IF ( myidy == id_stg_south  ) j = nys
+       IF ( myidy == id_stg_north )  j = nyn+1
+
+       volume_flow_l = 0.0_wp
+       volume_flow   = 0.0_wp
+       mc_factor_l   = 0.0_wp
+       mc_factor     = 0.0_wp
+       DO  i = nxl, nxr
           DO  k = nzb+1, nzt
-             mc_factor_l = mc_factor_l + dzw(k)  *                             &
-                           ( mean_inflow_profiles(k,1) + inflow_dist(k,j,1,1) )
+             volume_flow_l = volume_flow_l + v(k,j,i) * dzw(k) * dx         &
+                                  * MERGE( 1.0_wp, 0.0_wp,                  &   
+                                           BTEST( wall_flags_0(k,j,i), 2 ) )
+
+             mc_factor_l = mc_factor_l     + ( v(k,j,i) + dist_xz(k,i,2) )  &
+                                                      * dzw(k) * dx         &
+                                  * MERGE( 1.0_wp, 0.0_wp,                  &   
+                                           BTEST( wall_flags_0(k,j,i), 2 ) )
           ENDDO
        ENDDO
-
 #if defined( __parallel )
-       CALL MPI_ALLREDUCE( mc_factor_l, mc_factor,  &
-                           1, MPI_REAL, MPI_SUM, comm1dy, ierr )
+       CALL MPI_ALLREDUCE( volume_flow_l, volume_flow,                      &
+                           1, MPI_REAL, MPI_SUM, comm1dx, ierr )
+       CALL MPI_ALLREDUCE( mc_factor_l, mc_factor,                          &
+                           1, MPI_REAL, MPI_SUM, comm1dx, ierr )
 #else
-       mc_factor = mc_factor_l
+       volume_flow = volume_flow_l
+       mc_factor   = mc_factor_l
 #endif
 
-       mc_factor = volume_flow_initial(1) / mc_factor
-
-!
-!--    Add disturbance at the inflow
-       DO  j = nysg, nyng
-          DO  k = nzb, nzt+1
-              u(k,j,-nbgp+1:0) = ( mean_inflow_profiles(k,1) +                 &
-                                   inflow_dist(k,j,1,1)      ) * mc_factor
-              v(k,j,-nbgp:-1)  = ( mean_inflow_profiles(k,2) +                 &
-                                   inflow_dist(k,j,2,1)      ) * mc_factor
-              w(k,j,-nbgp:-1)  =   inflow_dist(k,j,3,1)        * mc_factor
+       mc_factor = volume_flow / mc_factor
+
+!
+!--    Add disturbances
+       IF ( myidy == id_stg_south  )  THEN
+
+          DO  i = nxlg, nxrg
+             DO  k = nzb, nzt+1
+                u(k,-nbgp:-1,i) = ( u(k,-nbgp:-1,i) + dist_xz(k,i,1) )         &
+                                     * mc_factor
+                v(k,-nbgp:0,i)  = ( v(k,-nbgp:0,i)  + dist_xz(k,i,2)  )        &
+                                     * mc_factor
+                w(k,-nbgp:-1,i) = ( w(k,-nbgp:-1,i) + dist_xz(k,i,3)  )        &
+                                     * mc_factor
+             ENDDO
           ENDDO
-       ENDDO
-
+       ENDIF
+       IF ( myidy == id_stg_north  )  THEN
+
+          DO  i = nxlg, nxrg
+             DO  k = nzb, nzt+1
+                u(k,nyn+1:nyn+nbgp,i) = ( u(k,nyn+1:nyn+nbgp,i) +              &
+                                          dist_xz(k,i,1) ) * mc_factor
+                v(k,nyn+1:nyn+nbgp,i) = ( v(k,nyn+1:nyn+nbgp,i) +              &
+                                          dist_xz(k,i,2) ) * mc_factor
+                w(k,nyn+1:nyn+nbgp,i) = ( w(k,nyn+1:nyn+nbgp,i) +              &
+                                          dist_xz(k,i,3) ) * mc_factor
+             ENDDO
+          ENDDO
+       ENDIF
     ENDIF
 
@@ -920,5 +1358,4 @@
 
  END SUBROUTINE stg_main
-
 
 !------------------------------------------------------------------------------!
@@ -931,5 +1368,5 @@
 !> parts are collected to form the full array.
 !------------------------------------------------------------------------------!
- SUBROUTINE stg_generate_seed_yz( n_y, n_z, b_y, b_z, f_n )
+ SUBROUTINE stg_generate_seed_yz( n_y, n_z, b_y, b_z, f_n, id )
 
 
@@ -940,4 +1377,5 @@
     IMPLICIT NONE
 
+    INTEGER(iwp) :: id          !< core ids at respective boundaries
     INTEGER(iwp) :: j           !< loop index in y-direction
     INTEGER(iwp) :: jj          !< loop index in y-direction
@@ -957,5 +1395,5 @@
     REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_y     !< filter func in y-dir
     REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_z     !< filter func in z-dir
-    REAL(wp), DIMENSION(nzb_x:nzt_x+1,nysg:nyng) :: f_n_l   !<  local velocity seed
+    REAL(wp), DIMENSION(nzb_x_stg:nzt_x_stg+1,nysg:nyng) :: f_n_l   !<  local velocity seed
     REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng)     :: f_n     !<  velocity seed
     REAL(wp), DIMENSION(:,:), ALLOCATABLE        :: rand_it !<  random number
@@ -1018,5 +1456,5 @@
 
     DO  j = nysg, nyng
-       DO  k = nzb_x, nzt_x+1
+       DO  k = nzb_x_stg, nzt_x_stg+1
           DO  jj = -n_y2(k), n_y2(k)
              DO  kk = -n_z2(k), n_z2(k)
@@ -1032,13 +1470,13 @@
 !
 !-- Gather velocity seeds of full subdomain
-    send_count = nzt_x - nzb_x + 1
-    IF ( nzt_x == nzt )  send_count = send_count + 1
+    send_count = nzt_x_stg - nzb_x_stg + 1
+    IF ( nzt_x_stg == nzt )  send_count = send_count + 1
 
 #if defined( __parallel )
-    CALL MPI_GATHERV( f_n_l(nzb_x,nysg), send_count, stg_type_yz_small,        &
-                      f_n(nzb+1,nysg), recv_count, displs, stg_type_yz,        &
-                      id_inflow, comm1dx, ierr )
+    CALL MPI_GATHERV( f_n_l(nzb_x_stg,nysg), send_count, stg_type_yz_small,        &
+                      f_n(nzb+1,nysg), recv_count_yz, displs_yz, stg_type_yz,        &
+                      id, comm1dx, ierr )
 #else
-    f_n(nzb+1:nzt+1,nysg:nyng) = f_n_l(nzb_x:nzt_x+1,nysg:nyng)
+    f_n(nzb+1:nzt+1,nysg:nyng) = f_n_l(nzb_x_stg:nzt_x_stg+1,nysg:nyng)
 #endif
 
@@ -1046,3 +1484,132 @@
  END SUBROUTINE stg_generate_seed_yz
 
+
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Generate a set of random number rand_it wich is equal on each PE
+!> and calculate the velocity seed f_n.
+!> f_n is splitted in vertical direction by the number of PEs in y-direction and
+!> and each PE calculates a vertical subsection of f_n. At the the end, all
+!> parts are collected to form the full array.
+!------------------------------------------------------------------------------!
+ SUBROUTINE stg_generate_seed_xz( n_x, n_z, b_x, b_z, f_n, id )
+
+
+    USE indices,                                                               &
+        ONLY: nx
+
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: id          !< core ids at respective boundaries
+    INTEGER(iwp) :: i           !< loop index in x-direction
+    INTEGER(iwp) :: ii          !< loop index in x-direction
+    INTEGER(iwp) :: k           !< loop index in z-direction
+    INTEGER(iwp) :: kk          !< loop index in z-direction
+    INTEGER(iwp) :: send_count  !< send count for MPI_GATHERV
+
+    INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_x    !< length scale in x-direction
+    INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_z    !< length scale in z-direction
+    INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_x2   !< n_y*2
+    INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_z2   !< n_z*2
+
+    REAL(wp) :: nxz_inv         !< inverse of number of grid points in xz-slice
+    REAL(wp) :: rand_av         !< average of random number
+    REAL(wp) :: rand_sigma_inv  !< inverse of stdev of random number
+
+    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_x     !< filter func in y-dir
+    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_z     !< filter func in z-dir
+    REAL(wp), DIMENSION(nzb_y_stg:nzt_y_stg+1,nxlg:nxrg) :: f_n_l   !<  local velocity seed
+    REAL(wp), DIMENSION(nzb:nzt+1,nxlg:nxrg)     :: f_n     !<  velocity seed
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE        :: rand_it !<  random number
+
+
+!
+!-- Generate random numbers using a seed generated in stg_init.
+!-- The set of random numbers are modified to have an average of 0 and
+!-- unit variance.
+    ALLOCATE( rand_it(nzb-mergp:nzt+1+mergp,-mergp:nx+mergp) )
+
+    rand_av        = 0.0_wp
+    rand_sigma_inv = 0.0_wp
+    nxz_inv        = 1.0_wp / REAL( ( nzt+1 - nzb+1 ) * ( nx+1 ), KIND=wp )
+
+    DO  i = 0, nx
+       DO  k = nzb, nzt+1
+          CALL RANDOM_NUMBER( rand_it(k,i) )
+          rand_av = rand_av + rand_it(k,i)
+       ENDDO
+    ENDDO
+
+    rand_av = rand_av * nxz_inv
+
+    DO  i = 0, nx
+       DO  k = nzb, nzt+1
+          rand_it(k,i)   = rand_it(k,i) - rand_av
+          rand_sigma_inv = rand_sigma_inv + rand_it(k,i) ** 2
+       ENDDO
+    ENDDO
+
+    rand_sigma_inv = 1.0_wp / SQRT(rand_sigma_inv * nxz_inv)
+
+    DO  i = 0, nx
+       DO  k = nzb, nzt+1
+          rand_it(k,i) = rand_it(k,i) * rand_sigma_inv
+       ENDDO
+    ENDDO
+
+!
+!-- Periodic fill of random number in space
+    DO  i = 0, nx
+       DO  k = 1, mergp
+          rand_it(nzb-k,i)   = rand_it(nzt+2-k,i)    ! bottom margin
+          rand_it(nzt+1+k,i) = rand_it(nzb+k-1,i)    ! top margin
+       ENDDO
+    ENDDO
+    DO  i = 1, mergp
+       DO  k = nzb-mergp, nzt+1+mergp
+          rand_it(k,-i)   = rand_it(k,nx-i+1)        ! left margin
+          rand_it(k,nx+i) = rand_it(k,i-1)           ! right margin
+       ENDDO
+    ENDDO
+
+!
+!-- Generate velocity seed following Eq.6 of Xie and Castro (2008)
+    n_x2 = n_x * 2
+    n_z2 = n_z * 2
+    f_n_l  = 0.0_wp
+
+    DO  i = nxlg, nxrg
+       DO  k = nzb_y_stg, nzt_y_stg+1
+          DO  ii = -n_x2(k), n_x2(k)
+             DO  kk = -n_z2(k), n_z2(k)
+                f_n_l(k,i) = f_n_l(k,i)                                        &
+                           + b_x(ii,k) * b_z(kk,k) * rand_it(k+kk,i+ii)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+
+    DEALLOCATE( rand_it )
+
+!
+!-- Gather velocity seeds of full subdomain
+    send_count = nzt_y_stg - nzb_y_stg + 1
+    IF ( nzt_y_stg == nzt )  send_count = send_count + 1
+
+
+#if defined( __parallel )
+    CALL MPI_GATHERV( f_n_l(nzb_y_stg,nxlg), send_count, stg_type_xz_small,        &
+                      f_n(nzb+1,nxlg), recv_count_xz, displs_xz, stg_type_xz,  &
+                      id, comm1dy, ierr )
+#else
+    f_n(nzb+1:nzt+1,nxlg:nxrg) = f_n_l(nzb_y_stg:nzt_y_stg+1,nxlg:nxrg)
+#endif
+
+
+ END SUBROUTINE stg_generate_seed_xz
+
  END MODULE synthetic_turbulence_generator_mod
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 2934)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 2938)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Nesting of dissipation rate in case of RANS mode and TKE-e closure is applied
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! Little formatting adjustment.
 ! 
@@ -358,6 +361,6 @@
                microphysics_morrison, microphysics_seifert, mid, nest_domain,  &
                neutral, nr_timesteps_this_run, nudging,                        &
-               ocean, passive_scalar,                                          &
-               prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
+               ocean, passive_scalar, prho_reference, pt_reference,            &
+               pt_slope_offset, random_heatflux, rans_mode,                    &
                rans_tke_e, run_coupled, simulated_time, simulated_time_chr,    &
                skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,        &
@@ -782,4 +785,8 @@
                 IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
 
+                IF ( .NOT. constant_diffusion  .AND.  rans_mode  .AND.         &
+                                                      rans_tke_e )             &
+                   CALL exchange_horiz( diss, nbgp )
+
                 IF ( air_chemistry )  THEN
                    DO  n = 1, nspec     
@@ -820,7 +827,5 @@
 !
 !--       Impose a turbulent inflow using synthetic generated turbulence
-          IF ( use_syn_turb_gen ) THEN 
-             CALL  stg_main
-          ENDIF
+          IF ( use_syn_turb_gen )  CALL  stg_main
 
 !
@@ -862,8 +867,8 @@
                                intermediate_timestep_count_max  )  THEN
              CALL forcing_bc
-          ENDIF
-!
-!--       Moreover, ensure mass conservation at each RK substep.
-          IF ( forcing )  CALL forcing_bc_mass_conservation
+!
+!--          Moreover, ensure mass conservation
+             CALL forcing_bc_mass_conservation
+          ENDIF
 
 !
Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 2938)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Further todo's
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! - defined l_grid only within this module
 ! - Moved l_wall definition from modules.f90
@@ -69,4 +72,6 @@
 !>       add OpenMP directives whereever possible
 !>       remove debug output variables (dummy1, dummy2, dummy3)
+!> @todo Move initialization of wall-mixing length from init_grid
+!> @todo Check for random disturbances
 !> @note <Enter notes on the module>
 !> @bug  TKE-e closure still crashes due to too small dt
@@ -284,5 +289,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  message_string, neutral, turbulent_inflow, turbulent_outflow
+        ONLY:  message_string, nest_domain, neutral, turbulent_inflow,         &
+               turbulent_outflow
 
     IMPLICIT NONE
@@ -302,6 +308,6 @@
              rans_tke_e = .TRUE.
 
-             IF ( INDEX( initializing_actions, 'set_1d-model_profiles' )       &
-                  == 0 )  THEN
+             IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) == 0  &
+                  .AND.  .NOT.  nest_domain )  THEN
                 message_string = 'Initializing without 1D model while ' //     &
                                  'using TKE-e closure&' //                     &
@@ -826,4 +832,7 @@
         ONLY:  use_sgs_for_particles, wang_kernel
 
+    USE pmc_interface,                                                         &
+        ONLY:  nested_run
+
     IMPLICIT NONE
 
@@ -847,7 +856,11 @@
     ALLOCATE( e_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
-
+!
+!-- Allocate arrays required for dissipation. 
+!-- Please note, if it is a nested run, arrays need to be allocated even if
+!-- they do not necessarily need to be transferred, which is attributed to 
+!-- the design of the model coupler which allocates memory for each variable. 
     IF ( rans_tke_e  .OR.  use_sgs_for_particles  .OR.  wang_kernel  .OR.      &
-         collision_turbulence )  THEN
+         collision_turbulence  .OR.  nested_run )  THEN
 #if defined( __nopointer )
        ALLOCATE( diss(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -858,5 +871,5 @@
 #else
        ALLOCATE( diss_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-       IF ( rans_tke_e )  THEN
+       IF ( rans_tke_e  .OR.  nested_run )  THEN
           ALLOCATE( diss_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
           ALLOCATE( diss_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -871,7 +884,7 @@
 
     IF ( rans_tke_e  .OR.  use_sgs_for_particles  .OR.     &
-         wang_kernel  .OR.  collision_turbulence )  THEN
+         wang_kernel  .OR.  collision_turbulence  .OR.  nested_run )  THEN
        diss => diss_1
-       IF ( rans_tke_e )  THEN
+       IF ( rans_tke_e  .OR.  nested_run )  THEN
        diss_p => diss_2; tdiss_m => diss_3
        ENDIF
